Index: unk/sources/HeuristicLab/3.3/CustomPostBuildTemplate_UpdateLocalInstallation.cmd
===================================================================
--- /trunk/sources/HeuristicLab/3.3/CustomPostBuildTemplate_UpdateLocalInstallation.cmd	(revision 13427)
+++ 	(revision )
@@ -1,22 +1,0 @@
-set target=C:\Program Files\HeuristicLab 3.3
-
-FOR /F "skip=1 tokens=1 delims= usebackq" %%G IN ("%ProjectDir%\Files.txt") DO copy "%Outdir%\%%G" "%target%" >nul
-
-echo "Platform: %Platform%, architecture: %PROCESSOR_ARCHITECTURE%"
-if "%Platform%" == "x86" (   
-  FOR /F "skip=1 tokens=* usebackq" %%G IN ("%ProjectDir%\Files.x86.txt") DO copy "%Outdir%\%%G" "%target%" >nul
-) else if "%Platform%" == "x64" ( 
-  FOR /F "skip=1 tokens=* usebackq" %%G IN ("%ProjectDir%\Files.x64.txt") DO copy "%Outdir%\%%G" "%target%" >nul
-) else if "%Platform%" == "AnyCPU" (
-  if "%PROCESSOR_ARCHITECTURE%" == "x64" (
-  FOR /F "skip=1 tokens=* usebackq" %%G IN ("%ProjectDir%\Files.x64.txt") DO copy "%Outdir%\%%G" "%target%" >nul
-  ) else if "%PROCESSOR_ARCHITECTURE%" == "x86" (
-  FOR /F "skip=1 tokens=* usebackq" %%G IN ("%ProjectDir%\Files.x86.txt") DO copy "%Outdir%\%%G" "%target%" >nul
-  ) else (
-    echo "ERROR: unknown architecture: "%PROCESSOR_ARCHITECTURE%"
-  ) 
-) else (
-  echo "ERROR: unknown platform: %Platform%"
-)
-
-echo "CustomPostBuild done"
Index: unk/sources/HeuristicLab/3.3/Files.txt
===================================================================
--- /trunk/sources/HeuristicLab/3.3/Files.txt	(revision 13427)
+++ 	(revision )
@@ -1,9 +1,0 @@
-﻿; This line is skipped. DO NOT TOUCH THIS line!
-; List of files that are to be copied to the installation directory
-
-HeuristicLab 3.3.exe
-HeuristicLab 3.3.exe.config
-*.dll
-*.txt
-mathjax.zip
-displayModelFrame.html
Index: unk/sources/HeuristicLab/3.3/Files.x64.txt
===================================================================
--- /trunk/sources/HeuristicLab/3.3/Files.x64.txt	(revision 13427)
+++ 	(revision )
@@ -1,3 +1,0 @@
-﻿; This line is skipped. DO NOT TOUCH THIS line!
-; This file contains a list of all x64 specific files
-
Index: unk/sources/HeuristicLab/3.3/Files.x86.txt
===================================================================
--- /trunk/sources/HeuristicLab/3.3/Files.x86.txt	(revision 13427)
+++ 	(revision )
@@ -1,3 +1,0 @@
-﻿; This line is skipped. DO NOT TOUCH THIS line!
-; This file contains a list of all x86 specific files
-
Index: /trunk/sources/HeuristicLab/3.3/HeuristicLab-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab/3.3/HeuristicLab-3.3.csproj	(revision 13427)
+++ /trunk/sources/HeuristicLab/3.3/HeuristicLab-3.3.csproj	(revision 13428)
@@ -224,10 +224,22 @@
 if exist "%25ProjectDir%25CustomPostBuild.cmd" call CustomPostBuild.cmd</PostBuildEvent>
     <PostBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
-export Outdir=$(Outdir)
+export OutDir=$(OutDir)
 export ProjectDir=$(ProjectDir)
 export SolutionDir=$(SolutionDir)
+export TargetDir=$(TargetDir)
 
 $SolutionDir/MergeConfigs.sh
 </PostBuildEvent>
   </PropertyGroup>
+  <PropertyGroup>
+    <PostBuildEvent>set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set OutDir=$(OutDir)
+set TargetDir=$(TargetDir)
+set Platform=$(PlatformName)
+set Configuration=$(ConfigurationName)
+
+call "$(SolutionDir)MergeConfigs.cmd"</PostBuildEvent>
+  </PropertyGroup>
 </Project>
Index: /trunk/sources/MergeConfigs.cmd
===================================================================
--- /trunk/sources/MergeConfigs.cmd	(revision 13427)
+++ /trunk/sources/MergeConfigs.cmd	(revision 13428)
@@ -1,15 +1,15 @@
 @echo off
 
-IF "%Outdir%"=="" (
-  SET Outdir=bin\
+IF "%TargetDir%"=="" (
+  SET TargetDir=.\bin\
   SET INTERACTIVE=1
 )
 
 echo Recreating HeuristicLab 3.3.exe.config...
-copy /Y "%Outdir%app.config" "%Outdir%HeuristicLab 3.3.exe.config"
+copy /Y "%TargetDir%app.config" "%TargetDir%HeuristicLab 3.3.exe.config"
 
 echo Merging...
-FOR /F "tokens=*" %%A IN ('dir /B "%Outdir%*.dll.config"') DO (
-  ConfigMerger "%Outdir%%%A" "%Outdir%HeuristicLab 3.3.exe.config"
+FOR /F "tokens=*" %%A IN ('dir /B "%TargetDir%*.dll.config"') DO (
+  "%SolutionDir%ConfigMerger.exe" "%TargetDir%%%A" "%TargetDir%HeuristicLab 3.3.exe.config"
 )
 
Index: /trunk/sources/MergeConfigs.sh
===================================================================
--- /trunk/sources/MergeConfigs.sh	(revision 13427)
+++ /trunk/sources/MergeConfigs.sh	(revision 13428)
@@ -1,11 +1,11 @@
-if [ "${Outdir}" == "" ]; then
-  Outdir=bin
+if [ "${TargetDir}" == "" ]; then
+  TargetDir=bin
 fi
 
 echo Recreating HeuristicLab 3.3.exe.config...
-cp $Outdir/app.config "$Outdir/HeuristicLab 3.3.exe.config"
+cp $TargetDir/app.config "$TargetDir/HeuristicLab 3.3.exe.config"
 
 echo Merging...
-for f in $(ls $Outdir/*.dll.config); do 
-		mono $SolutionDir/ConfigMerger.exe $f "$Outdir/HeuristicLab 3.3.exe.config"
+for f in $(ls $TargetDir/*.dll.config); do 
+		mono $SolutionDir/ConfigMerger.exe $f "$TargetDir/HeuristicLab 3.3.exe.config"
 done